## GdaDataModelDir GdaDataModelDir — GdaDataModel to list files in filesystem |

## Stability Level

Stable, unless otherwise indicated

## Functions

GdaDataModel * | gda_data_model_dir_new ()
const GSList * | gda_data_model_dir_get_errors ()
void | gda_data_model_dir_clean_errors ()

## Properties

gchar * | basedir | Read / Write / Construct Only

## Types and Values

struct | GdaDataModelDir
struct | GdaDataModelDirClass
| GdaDataModelDirPrivate

## Object Hierarchy

        GObject
        ╰── GdaDataModelDir

## Implemented Interfaces

GdaDataModelDir implements GdaDataModel.

## Description

The GdaDataModelDir object lists files on a filesystem which are located below a "basedir" directory, one file per row. The data model has the following columns:

- the "dir_name" column (G_TYPE_STRING): contains the dirname part of the file

- the "file_name" column (G_TYPE_STRING): contains the file name part of the file

- the "size" column (G_TYPE_UINT): contains the size in bytes of the file

- the "mime_type" column (G_TYPE_STRING): contains the mime type of the file (if GnomeVFS has been found, and NULL otherwise)

- the "md5sum" column (G_TYPE_STRING): contains the MD5 hash of each file (if LibGCrypt has been found, and NULL otherwise)

- the "data" column (GDA_TYPE_BLOB): contains the contents of each file

Note that the actual values of the "mime_type", "md5sum" and "data" columns are computed only when they are requested to help with performances.

## Functions

### gda_data_model_dir_new ()

    GdaDataModel *
    gda_data_model_dir_new (const gchar *basedir);

Creates a new GdaDataModel object to list all the files starting from `basedir`

#### Parameters

basedir | a directory |

#### Returns

a new GdaDataModel.

[transfer full]

### gda_data_model_dir_get_errors ()

    const GSList *
    gda_data_model_dir_get_errors (GdaDataModelDir *model);

Get the list of errors which have occurred while using `model`

#### Parameters

model | a GdaDataModelDir object |

#### Returns

(transfer none) (element-type GLib.Error) : a read-only list of GError pointers, or `NULL` if no error has occurred

### gda_data_model_dir_clean_errors ()

    void
    gda_data_model_dir_clean_errors (GdaDataModelDir *model);

Reset the list of errors which have occurred while using `model`

#### Parameters

model | a GdaDataModelDir object |

## Types and Values

### struct GdaDataModelDir

    struct GdaDataModelDir;

### struct GdaDataModelDirClass

    struct GdaDataModelDirClass {
    	GObjectClass            parent_class;
    };

### GdaDataModelDirPrivate

    typedef struct _GdaDataModelDirPrivate GdaDataModelDirPrivate;

## Property Details

### The `“basedir”` property

      “basedir”                  gchar *

Base directory.

Flags: Read / Write / Construct Only

Default value: NULL

## See Also

GdaDataModel